/*
  FileIO: una libreria per leggere e scrivere file di stringhe a lunghezza
  fissa.
  Versione originale C++: 10/12/2003
  Porting ANSI C: 30/10/2007
  Autore: Silvio Moioli
*/
#include "FileIO.h"

/* Apre un file con il nome specificato e lo inizializza */
FILE* newFile(){
	int i = 0;
    /* Riempie il file con il carattere di riempimento */
	FILE* fp = fopen(FILENAME, "w+b");
	for(i=0; i<FILELENGTH; i++){
	    fwrite("\0", 1, 1, fp);
	}
	return fp;
}

/* Scrive una stringa di lunghezza RECORDLENGTH nel file */
void fileWrite(FILE* fp, char* s, int pos){
	int len = strlen(s);
	char sf[RECORDLENGTH] = {0};
	int i;
	strncpy(sf, s, (len > RECORDLENGTH)? RECORDLENGTH : len);
	fseek(fp, RECORDLENGTH*pos, SEEK_SET);

    /* Scrive il record nel file, tagliandolo se troppo lungo */
	for(i=0; i<RECORDLENGTH; i++){
		fwrite(sf+i, 1, 1, fp);
	}
}

/* Legge una stringa di lunghezza RECORDLENGTH dal file */
char* fileRead(FILE* fp, int pos, char* s){
	fseek(fp, RECORDLENGTH*pos, SEEK_SET);
	fread(s, RECORDLENGTH, 1, fp);
    return s;
}
