/*
  FileIO: una libreria per leggere e scrivere file di stringhe a lunghezza
  fissa.
  Versione originale C++: 10/12/2003
  Porting ANSI C: 30/10/2007
  Autore: Silvio Moioli
*/

#ifndef FileIOH
#define FileIOH

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Il file dove i dati verranno memorizzati su disco */
#define FILENAME "dati.dat"
/* Lunghezza di ogni record */
#define RECORDLENGTH 10
/* Numero di record massimi nel file (sovradimensionare) */
#define RECORDSINFILE 100
/* Lunghezza in byte del file */
#define FILELENGTH RECORDLENGTH*RECORDSINFILE

/* Apre un file con il nome specificato e lo inizializza */
FILE* newFile();
/* Scrive una stringa di lunghezza RECORDLENGTH nel file */
void fileWrite(FILE* fp, char* s, int pos);
/* Legge una stringa di lunghezza RECORDLENGTH dal file */
char* fileRead(FILE* fp, int pos, char* s);

#endif
