/*
  HashFile: una libreria per leggere e scrivere file di stringhe a lunghezza
  fissa gestite attraverso una tabella hash.
  Versione originale C++: 10/12/2003
  Porting ANSI C: 30/10/2007
  Autore: Silvio Moioli
*/

#ifndef HashFileH
#define HashFileH

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "FileIO.h"

/* File con stringhe in una tabella hash */
typedef struct{
    FILE* fp;
    int collisioni;
    int n;
} HashFile;

/* Crea un nuovo file di hash */
HashFile* newHashFile();
/* Aggiunge un record, torna 0 se fallisce */
int hashFileAdd(HashFile* hf, char* s);
/* Ritorna la posizione del record nel file -1 se fallisce */
int hashFileWhere(HashFile* hf, char* s);
/* Ritorna il numero di collisioni avvenute */
int getCollisions(HashFile* hf);
/* Ritorna il numero di inserimenti avvenuti */
int getInsertions(HashFile* hf);

#endif